/************************************************************************************************

 Author        : ADI - Apps            www.analog.com/AduC7060

 Date          : November 2007

 File          : SPI_Slave.c

 Hardware      : ADuC706x

 Description   : This SPI Slave example shows how to initialise the SPI peripheral in Slave mode.

		
*************************************************************************************************/
#include<aduc7060.h>

// Bit Definitions
#define BIT0  0x01
#define BIT1  0x02
#define BIT2  0x04
#define BIT3  0x08
#define BIT4  0x10
#define BIT5  0x20
#define BIT6  0x40
#define BIT7  0x80
#define BIT8  0x100
#define BIT9  0x200
#define BIT10 0x400
#define BIT11 0x800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000
#define BIT16 0x10000
#define BIT17 0x20000
#define BIT22 0x400000
#define BIT24 0x1000000
#define BIT30 0x40000000

#include "common.h"
void delay(int); 


BYTE A0h[256], A2h[256];
BYTE SPI_first = TRUE;

unsigned char txCnt = 0;
unsigned char szTx[] = {0,0,0,0,
				   0,0,0,0,
				   0,0,0,0,
				   0,0,0,0};

unsigned char ucTxCnt = 0;
unsigned char ucRxCnt =0;
unsigned char ucEmptyCnt = 0;
unsigned char ucStopCnt =0;
unsigned char ucTestExtraRead = 0;
unsigned char ucFirstDataWrite = 0;
unsigned char Write_sequence = 0;
unsigned char ucTest = 0;
volatile unsigned char ucFirstEntry = 0;
unsigned char ucDummyRd = 0;

static BYTE byte_addr0 = 0x00;
static BYTE byte_addr2 = 0x00;
static BYTE wr_byte_addr0 = 0;
volatile unsigned char Test_addr0 = 0;
unsigned int uiFIFOSTATUS = 0;
unsigned int uiFIFOSTATUS1 = 0;
int main(void)
{
    unsigned int i;
	
	POWKEY1 = 0x1;
	POWCON0 = 0x78;		   // Set core to max CPU speed of 10.24Mhz
	POWKEY2 = 0xF4;

	GP1DAT  = BIT30;		// Configure P1.6 as an output
	// Configure P0.0, P0.1,P0.2 and P0.3 for SPI mode
	GP0CON0 = BIT0 + BIT4 + BIT8 + BIT12; // Select SPI/I2C alternative function for P0[0...3]
	GP0KEY1 = 0x7;		   //Write to GP0KEY1
	GP0CON1	= 0x00;	   // Select SPI functionality for P0.0 to  P0.3
	GP0KEY2 = 0x13;		   //Write to GP0KEY2

	// Enable SPI Slave mode and interrupt sources
	SPICON = BIT0    // Enable SPI 
		    + BIT9  // Clk pulses high at start of each bit + Initiate transfer on write to Tx FIFO
		   + BIT11;		   //Continuous transfer mode + Enable IRQ on 1 byte transfer
	IRQCONE = BIT1;			// Rising edge of XIRQ0
	IRQEN = BIT12 + BIT13; 		// Enable SPI + XIRQ0interrupt

	// Initialize table    
    for(i=0;i<256;i++){
        A0h[i]=i;
        A2h[i]=(255-i);
    }

    SPI_first = TRUE;
	while (1)
	{

	}
   return 0x00;
}

void IRQ_Handler(void) __irq
{
	unsigned long IRQSTATUS = 0;
	unsigned int SPIMSTATUS = 0;


	IRQSTATUS = IRQSTA;	   // Read off IRQSTA register

	if ((IRQSTATUS & BIT12) == BIT12)	//If SPI Slave interrupt source
	{
	   SPIMSTATUS = SPISTA;
	   ucFirstEntry = 1;
/*	   if ((SPIMSTATUS & BIT4) == BIT4) // If SPI Slave Tx buffer empty IRQ
	   {
		//	SPITX = 0x52;
			if (ucFirstEntry == 1)
			{
				SPITX = A0h[byte_addr0]; // set TX data + increment byte address
				szTx[txCnt++] = A0h[byte_addr0];
 				byte_addr0++;
				ucFirstEntry = 0;
			}
	   } */
  /*  if ((SPIMSTATUS & BIT5) == BIT5) // If SPI Slave Tx IRQ
	   {
		//	SPITX = 0x55;
			if (ucFirstEntry == 1)
			{
				SPITX = A0h[byte_addr0++]; // set TX data + increment byte address
				szTx[txCnt++] = A0h[byte_addr0];
 				byte_addr0++;
				ucFirstEntry = 0;
			}
	   } */
	   if ((SPIMSTATUS & BIT6) == BIT6) // If SPI Slave Rx IRQ
	   {
			if(SPI_first == TRUE)         // first slave-receiver INT?
			{     
			   byte_addr0 = SPIRX;   // get byte address
			   SPITX = byte_addr0;
			   if (byte_addr0 == 0)
			   {
			   	 Write_sequence= TRUE;
				}
//			   wr_byte_addr0 = byte_addr0; 			  		   
//			   byte_addr0++;                
			   SPI_first = FALSE;
			   ucFirstDataWrite = 1;
		 	} 
		   else
		 	{
				
				if (ucFirstDataWrite == 1)
				{
				 	 byte_addr0 = SPIRX;   // get byte address
				//	 SPITX = byte_addr0;
			   		 wr_byte_addr0 = byte_addr0; 
					 Test_addr0 = byte_addr0;
					 ucDummyRd = A0h[byte_addr0];
					 SPITX = ucDummyRd;
					 GP1DAT ^= BIT22;
					 byte_addr0++;
					 ucDummyRd = A0h[byte_addr0]; 			  		   
			   		  	GP1DAT ^= BIT22;               
			   		 ucFirstDataWrite = 0;
					 byte_addr0 -= 1;
//					 SPICON |= BIT13;			// Flush Master Tx FIFO
//					 SPICON &= ~BIT13;
				}
				else if (Write_sequence == TRUE)
				{				
				    A0h[wr_byte_addr0] = SPIRX;               // get byte data
					SPITX = A0h[wr_byte_addr0];
				  //  byte_addr0 = SPIRX;   // get byte address
				    byte_addr0++;		  // increment address				
					wr_byte_addr0++;
				    ucFirstDataWrite = 0; 
				} 
				else
				{
				//	SPICON |= BIT13;			// Flush Master Tx FIFO
				//	SPICON &= ~BIT13;
					ucTest = SPIRX;
					if (ucFirstEntry == 1)
					{
	//					ucDummyRd = SPIRX;
	//					SPICON |= BIT6;
						SPITX = ucDummyRd; 
						GP1DAT ^= BIT22;	// Toggle LED on Evaluation board (P1.6)
					//	SPITX = 0x55;
						ucDummyRd = A0h[byte_addr0]; // set TX data + increment byte address
						szTx[txCnt++] = A0h[byte_addr0];
						GP1DAT ^= BIT22;	// Toggle LED on Evaluation board (P1.6)
 						byte_addr0++;
						ucFirstEntry = 0;
					}
			//		SPITX = 0x95;
						ucTest++;
				}
		    }


	   }
	   // Test for SPICON.8/SPISTA.7 - remove reading fo SPIRX register
	   if ((SPIMSTATUS & BIT7) == BIT7) // If SPI Slave Rx FIFO Overflow status IRQ
	   {
		   	
	   }
	}
	if ((IRQSTATUS & BIT13) == BIT13)	//XIRQ0 interrupt source - Reset counters
	{
		IRQCLRE = BIT13;
		IRQCLR = BIT13;
		SPI_first = TRUE;
		ucFirstDataWrite = 0;
		byte_addr0 = 0;
		wr_byte_addr0 = 0;
		ucTest = 0;
		Write_sequence = 0;
		SPICON |= BIT13;			// Flush Master Tx FIFO
		SPICON &= ~BIT13;
		SPICON |= BIT12;			// Flush Master Rx FIFO
		SPICON &= ~BIT12;
		SPICON &= ~BIT6;
		IRQEN |= BIT13;
		txCnt = 0;
	}
}


